meal_plans/urls.py
from django.urls import path

from meal_plans.views import (
    MealPlanView,
    MealPlanDetailView,
    MealPlanCreateView,
    MealPlanDeleteView,
    MealPlanUpdateView,
)

urlpatterns = [
    path("", MealPlanView.as_view(), name="meal_plan_list"),
    path("<int:pk>/", MealPlanDetailView.as_view(), name="meal_plan_detail"),
    path(
        "<int:pk>/delete/",
        MealPlanDeleteView.as_view(),
        name="meal_plan_delete",
    ),
    path("new/", MealPlanCreateView.as_view(), name="meal_plan_new"),
    path("<int:pk>/edit/", MealPlanUpdateView.as_view(), name="meal_plan_edit"),
]

scrumptious/urls.py
from django.contrib import admin
from django.urls import include, path, reverse_lazy
from django.views.generic.base import RedirectView
from django.contrib.auth import views as auth_views

urlpatterns = [
    path("accounts/login/", auth_views.LoginView.as_view(), name="login"),
    path("accounts/logout/", auth_views.LogoutView.as_view(), name="logout"),
    path("admin/", admin.site.urls),
    path("recipes/", include("recipes.urls")),
    path("tags/", include("tags.urls")),
    path("meal_plans/", include("meal_plans.urls")),
    path(
        "",
        RedirectView.as_view(url=reverse_lazy("recipes_list")),
        name="home",
    ),
]

tags/urls.py
from django.urls import path

from tags.views import (
    TagListView,
    TagDeleteView,
    TagDetailView,
    TagCreateView,
    TagUpdateView,
)

urlpatterns = [
    path("", TagListView.as_view(), name="tags_list"),
    path("<int:pk>/", TagDetailView.as_view(), name="tag_detail"),
    path("<int:pk>/delete/", TagDeleteView.as_view(), name="tag_delete"),
    path("new/", TagCreateView.as_view(), name="tag_new"),
    path("<int:pk>/edit/", TagUpdateView.as_view(), name="tag_edit"),
]

meal_plans/models.py
from django.db import models
from django.conf import settings

USER_MODEL = settings.AUTH_USER_MODEL

# Create your models here.
class MealPlan(models.Model):
    name = models.CharField(max_length=120)
    date = models.DateTimeField(auto_now_add=False)
    owner = models.ForeignKey(
        USER_MODEL,
        related_name="meal_plans",
        on_delete=models.CASCADE,
        null=True,
    )
    recipes = models.ManyToManyField(
        "recipes.Recipe", related_name="meal_plans"
    )

    def __str__(self):
        return self.name

meal_plans/forms.py
from django.forms import ModelForm, DateInput, DateField

from meal_plans.models import MealPlan


class CustomDateInput(DateInput):
    input_type = "date"


class MealPlanForm(ModelForm):
    date = DateField(widget=CustomDateInput)

    class Meta:
        model = MealPlan
        fields = ["name", "recipes", "date"]

meal_plans/views.py
from django.urls import reverse_lazy
from django.shortcuts import redirect
from django.contrib.auth.mixins import LoginRequiredMixin
from django.views.generic.detail import DetailView
from django.views.generic.list import ListView
from django.views.generic.edit import CreateView, DeleteView, UpdateView

from meal_plans.models import MealPlan
from meal_plans.forms import MealPlanForm

# Create your views here.
class MealPlanView(LoginRequiredMixin, ListView):
    model = MealPlan
    template_name = "meal_plans/list.html"

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanCreateView(LoginRequiredMixin, CreateView):
    model = MealPlan
    template_name = "meal_plans/new.html"
    form_class = MealPlanForm

    def form_valid(self, form):
        plan = form.save(commit=False)
        plan.owner = self.request.user
        plan.save()
        form.save_m2m()
        return redirect("meal_plan_list")


class MealPlanDetailView(LoginRequiredMixin, DetailView):
    model = MealPlan
    template_name = "meal_plans/detail.html"

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)


class MealPlanUpdateView(LoginRequiredMixin, UpdateView):
    model = MealPlan
    template_name = "meal_plans/edit.html"
    fields = ["name", "date", "recipes"]

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)

    def get_success_url(self):
        return reverse_lazy("meal_plan_detail", args=[self.object.id])


class MealPlanDeleteView(LoginRequiredMixin, DeleteView):
    model = MealPlan
    template_name = "meal_plans/delete.html"
    success_url = reverse_lazy("meal_plan_list")

    def get_queryset(self):
        return MealPlan.objects.filter(owner=self.request.user)

meal_plans/templates/meal_plans/delete.html
{% extends 'base.html' %}
{% block delete %}
    <main>
        {{ user.username }}
        <div class="delete-form">
            <form method="post">
                {% csrf_token %}
                <p>Are you sure you want to delete "{{ mealplan.name }}"?</p>
                {{ form.as_p }}
                <div>
                    <button class="button">Delete</button>
                </div>
            </form>
        </div>
    </main>
{% endblock delete %}

meal_plans/templates/meal_plans/detail.html
{% extends 'base.html' %}
{% load markdownify %}
{% block meal_detail %}
    <main class="tag-detail">
        <div>
            <a href="{% url 'meal_plan_edit' mealplan.id %}">Edit</a>
            <a href="{% url 'meal_plan_delete' mealplan.id %}">Delete</a>
        </div>
        <h2>Recipes for {{ mealplan.name }}</h2>
        {% for recipe in mealplan.recipes.all %}
            <p>
                <a href="{% url 'recipe_detail' recipe.pk %}">{{ recipe.name }}</a>
            </p>
        {% endfor %}
    </main>
{% endblock meal_detail %}

meal_plans/templates/meal_plans/edit.html
{% extends 'base.html' %}
{% block meal_edit %}
    <main class="recipe-grid">
        {% for plan in meal_plan_list %}
            <div class="recipe-card">
                <h2 class="recipe-card-title">
                    <a href="{% url 'meal_plan_detail' recipe.pk %}">{{ meal_plans.name }}</a>
                </h2>
                <p class="recipe-card-date">{{ meal_plan.updated }}</p>
            </div>
        {% endfor %}
    </main>
{% endblock meal_edit %}

meal_plans/templates/meal_plans/list.html
{% extends 'base.html' %}
{% block meal_list %}
    <main class="recipe-grid">
        <div>
            <p>
                <h2>
                    Would you like to
                    <a href="{% url 'meal_plan_new' %}">create</a>
                    a meal plan?
                </h2>
            </p>
        </div>
        {% for meal in mealplan_list %}
            <div class="recipe-card">
                <h2 class="recipe-card-title">
                    <a href="{% url 'meal_plan_detail' meal.pk %}">{{ meal.name }}</a>
                </h2>
            {% endfor %}
        </main>
    {% endblock meal_list %}

meal_plans/templates/meal_plans/new.html
{% extends 'base.html' %}
{% block meal_new %}
    <main class="recipe-form">
        <form method="post">
            {% csrf_token %}
            {{ form.as_p }}
            <div class="control">
                <button class="button">Create</button>
            </div>
        </form>
    </main>
{% endblock meal_new %}